<?php

namespace App\Http\Controllers;


use Twilio\Rest\Verify\V2\Service\VerificationCheckInstance;
use Twilio\Rest\Client;
use Illuminate\Http\Request;
use App\User;
class AuthController extends Controller
{
    //
    public function postLogin(Request $request){
        $credentials = [
            'email' => $request['username'],
            'password' => $request['password'],
        ];
        if(!\Auth::attempt($credentials)){
            return redirect()->back();
        }
        else if(\Auth::attempt($credentials) && \Auth::user()->role == 1)
        return redirect()->route('admin');
        
        else if(\Auth::attempt($credentials) && \Auth::user()->role == 2)
        return redirect()->route('user');
    }

    public function postRegister(Request $request){
        $this->validate($request,[
            'username' =>'required|min:4',
            'email'=>'required|email|unique:users',
            'password'=>'required|min:6|confirmed'
        ]);
        $token = getenv("TWILIO_AUTH_TOKEN");
        $twilio_sid = getenv("TWILIO_SID");
        $twilio_verify_sid = getenv("TWILIO_VERIFY_SID");
        $twilio = new Client($twilio_sid, $token);
        $twilio->verify->v2->services($twilio_verify_sid)
            ->verifications
            ->create($request->number, "sms");
        
        User::create([
            'firstname' => $request->namadepan,
            'lastname' => $request->namabelakang,
            'gender' => $request->gender,
            'username' => $request->username,
            'email'=> $request->email,
            'password'=>bcrypt($request->password),
            'role'=> $request->role,
            'phone_number'=>$request->number,
        ]);

        return redirect()->route('verify')->with(['phone_number' => $request->number]);
    }
    public function login(){
        return view('index');
    }
    
    public function register(){
        return view('index');
    }
    public function logout(){
        \Auth::logout();

        return redirect()->route('back');
    }
    protected function verify(Request $request)
    {
        $data = $request->validate([
            'verification_code' => ['required', 'numeric'],
            'phone_number' => ['required', 'string'],
        ]);
        /* Get credentials from .env */
        $token = getenv("TWILIO_AUTH_TOKEN");
        $twilio_sid = getenv("TWILIO_SID");
        $twilio_verify_sid = getenv("TWILIO_VERIFY_SID");
        $twilio = new Client($twilio_sid, $token);
        
        $verification = $twilio->verify->v2->services($twilio_verify_sid)
            ->verificationChecks
            ->create($data['verification_code'], array('to' => $data['phone_number']));
                    if ($verification->valid) {
            $user = tap(User::where('phone_number', $data['phone_number']))->update(['isVerified' => true]);
            /* Authenticate user */
            \Session::flash('sukses','Nomor sudah terverifikasi silahkan login');
            return redirect()->route('back');
        }
        return back()->with(['phone_number' => $data['phone_number'], 'error' => 'Invalid verification code entered!']);
    }
}
